(* seplog (c) AIST 2005-2015. R. Affeldt, N. Marti, et al. GNU GPLv3. *)
Require Import Bool.
From mathcomp Require Import ssreflect ssrbool.
Export Bool.

Lemma andbR {a b : bool} : a && b -> b.
Proof. by case/andP. Qed.

Lemma andbL {a b : bool} : a && b -> a.
Proof. by case/andP. Qed.

Definition andb_option (a b : option bool) :=
  match a with
    | None => None
    | Some a' => match b with
                   | None => None
                   | Some b' => Some (andb a' b')
                 end
  end.

Definition orb_option (a b : option bool) :=
  match a with
    | None => None
    | Some a' => match b with
                   | None => None
                   | Some b' => Some (orb a' b')
                 end
  end.
