(* seplog (c) AIST 2005-2015. R. Affeldt, N. Marti, et al. GNU GPLv3. *)
From mathcomp Require Import ssreflect ssrbool eqtype ssrnat.
From mathcomp Require Import div.
Export div.

Lemma dvdn_0 : forall n, n <> 0 -> ~ 0 %| n. Proof. rewrite /dvdn /modn. case => //=. Qed.

Lemma divn_lt0 : forall a b, 0 < a -> 0 < a %/ (gcdn a b).
Proof.
move=> a b Ha.
rewrite divn_gt0.
apply dvdn_leq => //.
apply dvdn_gcdl.
rewrite gcdn_gt0 Ha //.
Qed.

Lemma modn_subr_eq m a b : b * m <= a -> a - b * m = a %[mod b].
Proof.
move=> H.
apply/eqP.
by rewrite -(eqn_modDr (b * m)) subnK // addnC mulnC modnMDl.
Qed.

